subpackage oper
@ bindctl(sequence ^E set parse_command _spageu)
@ bindctl(sequence ^D set parse_command _spaged)

alias _spageu {
	@:_cwin=winnum()
	window ref operview
		parsekey SCROLL_BACKWARD
			window ref $_cwin
}

alias _spaged {
	@:_cwin=winnum()
    window ref operview
    	parsekey SCROLL_FORWARD
        	window ref $_cwin
}

alias _winnames {
	fe ($winrefs()) n1 {
		if (match($0 $winnam($n1)) > 0) {
			return $n1
			
		}{
			return 0
		}
	}
}

alias ovsize {   
        if (![$0]) {
                xecho -v [mod] (oper).. operview window size set to "$_ovsize" 
        }{
                @_ovsize=[$0]
                xecho -v [mod] (oper).. operview window size set to "$_ovsize" 
        }
}
                         
alias ovmode { 
        if (![$0]) {
        xecho -v [mod] (oper).. oper modes set to "$_ovmode"
        }{
        @_ovmode=[$0]
        xecho -v [mod] (oper).. oper modes set to "$_ovmode"
        }
}

/ON -SERVER_NOTICE "*requesting gline for*" {
@glineTarget=strip([] [$11]);
@glineReason=strip([] [$12-]); }

ALIAS gi {
input "GLINE $glineTarget for '$glineReason'? (y/n) " {
if ( [$0] == [y] ) /quote gline $glineTarget :$glineReason
}
}

alias operview {
	if (winnum(operview) != -1) {
		abecho [a+x] toggled operview off.
			^window OperView kill
			^umode -$_ovmode
		
	}{
		
				abecho [a+x] toggled operview on.
					^window new fixed on size $_ovsize name OperView level snotes,opnotes,wallops;umode +$_ovmode
#					^set status_server [%S]
					^set status_format [operview] %> [$servername($winserv(OperView))]
					^window back
						
	}
}



alias tfind  {
	^on ^206 * #
	^on ^204 * #
	^on ^206 * #	
	^on ^209 * #
	^on ^262 * #
	switch ($0) {
		(-kill) {
		@_khost=[$1]
		@_kreas=[$2-]
			if (match(*@* $_khost) || match(*.* $_khost)) {
				^trace
					^on ^205 * {
						if (match($_khost $sar(g/]//$after([ $3)))) {
							xecho -b killing $3
							if ([$_kreas]) {
							kill $before([ $3) $_kreas
							}{
							kill $before([ $3) goodbye.
							}
						}		
					}	
				
			}{
				^trace
					^on ^205 * {
						
						if (match($_khost $(before([ $3))!$(sar(g/]//$after([ $3))))) {
							xecho -b killing $3
							if ([$_kreas]) {
								kill $before([ $3) $_kreas	
							}{

								kill $before([ $3) goodbye					
							}
						}	
					}
			
			}
		}
		(-match) {
			@_mhost=[$1]
				^trace
					xecho      $a.ver /tfind match for $1
					banner.head
					^on ^205 * {
						
						if (match($_mhost $(before([ $4))!$(sar(g/]//$after([ $4))))) {
				
							banner.mid $1-
						}
					
					}
						^on ^204 * {
							if (match($_mhost $(before([ $4))!$(sar(g/]//$after([ $4))))) {
								banner.mid $1-
							}
						}
						^on ^262 * {		
							banner.foot
						}
		}





	}		
			wait
			^on ^203 -*
		    ^on ^204 -* 
			^on ^206 -*
			^on ^209 -*
			^on ^262 -* 
			^on ^205 -*
			^on ^262 -*
}

alias doper {
	umode -o 
}

alias operwall {
	quote operwall :$*
}
alias locops {
	quote locops :$*
}
alias tkline {
	if (![$0]) {
		xecho -v [a+c] usage: /tkline <minutes> [nick|hostmask] <reason>
	}{
		quote kline $0 $1 :$2-
	}
}
alias kline {
	if (match(*@* $0)) {
		quote kline $0 :$1-
	}{
		if (getuhost($0)) {
			quote kline $sar(g/*!*//$mask(3 $getuhost($0))) :$1-
		}{
			obecho $0 no such nick. 
		}
	}
}

alias unkline {
	quote unkline $*
}

alias kill {
	quote kill $0 :$1-
}

alias mkill {
	if (![$0]) {
		fe ($remw($N $chanusers($C))) n1 {
			quote kill $n1 :bye
		}
	}{
		 fe ($remw($N $chanusers($C))) n1 {
      		quote kill $n1 :$*
		}
	} 	
}           

alias mkline {
	if (![$0]) {   
    	fe ($remw($N $chanusers($C))) n1 {
      		kline $n1
    	} 
    }{
     	fe ($remw($N $chanusers($C))) n1 {
      		kline $n1 $*
      	}           
    }
}

alias gline {
	quote gline $0 :$1-
}

alias cjupe {
	quote mode $0 +j
}
alias ucjupe {
	quote mode $0 -j
}

alias modlist {
quote modlist 
}
alias modload {
quote modload $*
}
alias modunload {
quote modunload $*
}

^on ^server_notice "% % % % % % % % % /whois*" {
	aecho $fparse(format_timestamp_some $($_timess))[$9] on you requested by $4!$5)
}

/on ^server_notice "*TRACE requested*" #
/on ^server_notice "*Too many clients*" #
/on ^server_notice "*farcans*nitedog*never*leaves*" #
/on ^server_notice "*locally juped channel*" #
/on ^server_notice "*drone flooder *dcc*" #
/on ^server_notice "*irc.stats.gatherer* being introduced*" #
/on ^server_notice "*irc.stats.gatherer* split from*" #      
/on ^server_notice "*stats.efnet.info* being introduced*" #
/on ^server_notice "*stats.efnet.info* split from*" #      
/on ^server_notice "*stats.blackened.com* being introduced*" #
/on ^server_notice "*stats.blackened.com* split from*" #      
/on ^server_notice "*Temporary K-line for*expired*" #      
/on ^server_notice "*I-line is full for*" #
/on ^server_notice "*john23*spambot*" #

^on ^server_notice "% % % % LINKS*" {
	aecho $fparse(format_timestamp_some $($_timess))[links $5] requested by $8!$9 $10
}

^on ^server_notice "% % % % STATS*" {
	aecho $fparse(format_timestamp_some $($_timess))[stats '$5'] requested by $8!$9) $10
}

^on ^server_notice "% % % % % % % % % (O)*" {
	aecho $fparse(format_timestamp_some $($_timess))$4!$5 is now a $8 $9
}

^on ^server_notice "% % % % % exiting:*" {
	aecho $fparse(format_timestamp_some $($_timess))Client exiting: $6!$7 $8-
}

^on ^server_notice "% % % % % connecting:*" {
	aecho $fparse(format_timestamp_some $($_timess))Client connecting: $6!$7 $8-
}

^on ^server_notice "% % % % % % rehashing*" {
	aecho $fparse(format_timestamp_some $($_timess))$4 is rehashing $7- 
}

^on ^server_notice "% % % % ADMIN*" {
	aecho $fparse(format_timestamp_some $($_timess))[Admin] requested by $7!$8 $9-
}

^on ^server_notice "% % % % % SQUIT*" {
	aecho $fparse(format_timestamp_some $($_timess))$4 $5 $6 from $8 $9-
}

^on ^server_notice "% % % % % was connected*" {
	aecho $fparse(format_timestamp_some $($_timess)) $4 $5 $6 $7 $8 $9 $10-
}

^on ^server_notice "% % % % Link with*" {
	aecho $fparse(format_timestamp_some $($_timess))Link $5 $6 $7-
}

^on ^server_notice "% % % % % % already present*" {
	aecho $4$fparse(format_timestamp_some $($_timess))$5 $6 $7 from $9
}

^on ^382 * {
	aecho $1-
}
#^on ^364 * {
#	aecho $1-
#}

^on ^365 * {
	aecho $1 $2 of links list.
} 

^on ^243 * {
	aecho $1-
}

^on ^219 * {
	aecho $1 $2 of stats list.
}
